diff -r 11a8f1275a38 sys/netinet/tcp_var.h
--- a/sys/netinet/tcp_var.h	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/netinet/tcp_var.h	Mon Mar 11 02:59:51 2013 +1100
@@ -46,14 +46,21 @@
 
 #endif /* _KERNEL */
 
+/* Subflow send buffer mapping queue entry */
+struct sfsendmap_qent {
+	TAILQ_ENTRY(sfsendmap_qent) sfmap_q;
+	int send_chars;
+	void *sendbuf_idx;
+};
+
 /* TCP segment queue entry */
 struct tseg_qent {
-	LIST_ENTRY(tseg_qent) tqe_q;
+	TAILQ_ENTRY(tseg_qent) tqe_q;
+	uint64_t tqe_dsn;		/* The DSN for this entry */
 	int	tqe_len;		/* TCP segment data length */
 	struct	tcphdr *tqe_th;		/* a pointer to tcp header */
 	struct	mbuf	*tqe_m;		/* mbuf contains packet */
 };
-LIST_HEAD(tsegqe_head, tseg_qent);
 
 struct sackblk {
 	tcp_seq start;		/* start seq no. of sack block */
@@ -95,21 +102,45 @@
 #define ND6_HINT(tp)
 #endif
 
+/* Used to map outgoing and incoming segments. Maintained in
+ * t_txmaps and t_rxmaps lists. mbuf_start and mbuf_offset
+ * are not used in the rx context.
+ */
+struct ds_map {
+	TAILQ_ENTRY(ds_map) sf_ds_map_next;
+	TAILQ_ENTRY(ds_map) mp_ds_map_next;
+	uint64_t ds_map_start;	/* starting DSN of mapping */
+	uint32_t ds_map_len;	/* length of data sequence mapping */
+//	uint32_t ds_map_offset;	/* bytes sent from mapping */
+	tcp_seq	sf_seq_start; /* starting tcp seq num of mapping */
+//	uint64_t map_una;		/* bytes sent but unacknowledged in map */
+	uint16_t ds_map_csum;	/* csum of dss psuedo-header and all mapping data */
+	struct mbuf* mbuf_start; /* mbuf in send sockbuf in which this mappings starts */
+	u_int	mbuf_offset;	/* offset into mbuf where data starts */
+	uint32_t flags;
+};
+TAILQ_HEAD(dsmapq_head, ds_map);
+
 /*
  * Tcp control block, one per tcp; fields:
  * Organized for 16 byte cacheline efficiency.
  */
 struct tcpcb {
-	struct	tsegqe_head t_segq;	/* segment reassembly queue */
 	void	*t_pspare[2];		/* new reassembly queue */
 	int	t_segqlen;		/* segment reassembly queue length */
 	int	t_dupacks;		/* consecutive dup acks recd */
 
+	struct	sf_reass_queue_head *t_segq;	/* points to head of reass queue */
+
 	struct tcp_timer *t_timers;	/* All the TCP timers in one struct */
 
 	struct	inpcb *t_inpcb;		/* back pointer to internet pcb */
+	struct	mpcb *t_mpcb;		/* back pointer to multipath cb */
+
 	int	t_state;		/* state of this connection */
+	int sf_state;		/* mp state for slave subflows */
 	u_int	t_flags;
+	u_int	sf_flags;	/* flags for this subflow */
 
 	struct	vnet *t_vnet;		/* back pointer to parent vnet */
 
@@ -194,6 +225,7 @@
 	int	t_rttlow;		/* smallest observerved RTT */
 	u_int32_t	rfbuf_ts;	/* recv buffer autoscaling timestamp */
 	int	rfbuf_cnt;		/* recv buffer autoscaling byte count */
+	//struct toe_usrreqs *t_tu;	/* offload operations vector */
 	struct toedev	*tod;		/* toedev handling this connection */
 	int	t_sndrexmitpack;	/* retransmit packets sent */
 	int	t_rcvoopack;		/* out-of-order packets received */
@@ -211,6 +243,20 @@
 	uint32_t t_ispare[8];		/* 5 UTO, 3 TBD */
 	void	*t_pspare2[4];		/* 4 TBD */
 	uint64_t _pad[6];		/* 6 TBD (1-2 CC/RTT?) */
+
+	/* MULTIPATH */
+	uint8_t	mp_enabled:1,	/* try to use mptcp (sysctl is enabled) */
+			mp_active:1,	/* mp session is active on this flow */
+			mpc:1,			/* other end supports mptcp */
+			sent_capable:1;	/* sent mp_cable */
+
+	struct dsmapq_head t_txdsmaps;	/* data sequence map outgoing */
+	struct dsmapq_head t_rxdsmaps;	/* data sequence map incoming */
+	u_long	init_cwnd;	/* establish mptcp once this window fills */
+	uint32_t local_rand;	/* random number for join HMAC */
+	uint32_t remote_rand;	/* random number for join HMAC */
+	uint32_t mp_conn_token;	/* mp session this belongs to */
+	SLIST_ENTRY(tcpcb) next_subflow;
 };
 
 /*
@@ -230,6 +276,7 @@
 #define	TF_NEEDFIN	0x000800	/* send FIN (implicit state) */
 #define	TF_NOPUSH	0x001000	/* don't push */
 #define	TF_PREVVALID	0x002000	/* saved values for bad rxmit valid */
+#define	TF_MPTCP		0x004000	/* MPTCP options present */
 #define	TF_MORETOCOME	0x010000	/* More data to be appended to sock */
 #define	TF_LQ_OVERFLOW	0x020000	/* listen queue overflow */
 #define	TF_LASTIDLE	0x040000	/* connection was previously idle */
@@ -245,6 +292,7 @@
 #define	TF_ECN_SND_ECE	0x10000000	/* ECN ECE in queue */
 #define	TF_CONGRECOVERY	0x20000000	/* congestion recovery mode */
 #define	TF_WASCRECOVERY	0x40000000	/* was in congestion recovery */
+#define	TF_NEED_DFIN	0x80000000	/* send mptcp DFIN */
 
 #define	IN_FASTRECOVERY(t_flags)	(t_flags & TF_FASTRECOVERY)
 #define	ENTER_FASTRECOVERY(t_flags)	t_flags |= TF_FASTRECOVERY
@@ -281,6 +329,40 @@
 #define	TCP_SIG_SPI	0x1000
 #endif /* TCP_SIGNATURE */
 
+struct mpopt {
+	uint64_t	mpo_flags;		/* flags for this option */
+	uint8_t		to_mpsubtype;	/* the mptcp option subtype */
+	uint8_t		to_mpoptlen;	/* length of the mptcp option for this segment */
+	uint32_t	add_addr_mask;	/* Bit mask of addresses that have been advertised */
+	uint32_t	join_mask;		/* Addresses we have sent joins for */
+
+	/* KEYS */
+	uint64_t	local_key;	/* locally generated key */
+	uint64_t	remote_key;	/* key generated by remote host */
+
+	/* MP_JOIN */
+	uint32_t	rcv_token;	/* mp_join receive token */
+	uint32_t	snd_rnd;	/* mp_join sender random number */
+	uint64_t	snd_trc_mac;	/* mp_join sender truncated mac */
+
+	/* MP_ADD */
+	struct sockaddr_storage	new_addr;	/* a new address */
+
+	/* DSS */
+	uint64_t	data_ack_num;	/* data ack value */
+	uint64_t	data_seq_num;	/* data sequence number (only 64-bit support for now) */
+	uint64_t	truncated_MAC;	/* truncated (upper 64-bits) MAC for MP_JOIN */
+	uint32_t	sub_seq_num;	/* subflow sequence number */
+	uint16_t	dss_data_len;	/* Data-level length 0 means no DSN */
+	uint16_t	dss_csum;	/* checksum */
+	uint16_t	*dss_data_len_p; /* Pointer to data length in option char */
+	uint8_t		*dss_opts_f_p;	/* pointer to dss flags */
+
+	int		optlen;			/* use this to identify types in segment processing */
+	uint8_t	addr_id;		/* address id, used in mp_join */
+	char	snd_mac[20];	/* senders MAC, 160-bit sha */
+};
+
 /*
  * Structure to hold TCP options that are only used during segment
  * processing (in tcp_input), but not held in the tcpcb.
@@ -297,7 +379,8 @@
 #define	TOF_TS		0x0010		/* timestamp */
 #define	TOF_SIGNATURE	0x0040		/* TCP-MD5 signature option (RFC2385) */
 #define	TOF_SACK	0x0080		/* Peer sent SACK option */
-#define	TOF_MAXOPT	0x0100
+#define	TOF_MPTCP	0x0100		/* MPTCP options present */
+#define	TOF_MAXOPT	0x0200
 	u_int32_t	to_tsval;	/* new timestamp */
 	u_int32_t	to_tsecr;	/* reflected timestamp */
 	u_char		*to_sacks;	/* pointer to the first SACK blocks */
@@ -306,6 +389,7 @@
 	u_int8_t	to_wscale;	/* window scaling */
 	u_int8_t	to_nsacks;	/* number of SACK blocks */
 	u_int32_t	to_spare;	/* UTO */
+	struct	mpopt	to_mopts;	/* multipath options */
 };
 
 /*
@@ -642,6 +726,15 @@
 VNET_DECLARE(struct hhook_head *, tcp_hhh[HHOOK_TCP_LAST + 1]);
 #define	V_tcp_hhh		VNET(tcp_hhh)
 
+VNET_DECLARE(int, tcp_do_mptcp);	/* MPTCP enabled/disabled */
+#define	V_tcp_do_mptcp		VNET(tcp_do_mptcp)
+
+/*
+ * XXXNJW: use zone allocator. Potentially could have many maps
+ * being alloc'd and dealloc'd if using one map per packet
+ */
+MALLOC_DECLARE(M_DSSMAP);
+
 int	 tcp_addoptions(struct tcpopt *, u_char *);
 int	 tcp_ccalgounload(struct cc_algo *unload_algo);
 struct tcpcb *
@@ -669,6 +762,7 @@
 int	 tcp_reass(struct tcpcb *, struct tcphdr *, int *, struct mbuf *);
 void	 tcp_reass_init(void);
 void	 tcp_reass_flush(struct tcpcb *);
+void	 tcp_reass_release_element(struct tseg_qent *q);
 #ifdef VIMAGE
 void	 tcp_reass_destroy(void);
 #endif
@@ -736,6 +830,20 @@
 
 void	cc_cong_signal(struct tcpcb *tp, struct tcphdr *th, uint32_t type);
 
+#define IS_MASTER_TP(tp) ((tp->t_mpcb->master_tcpcb) == (tp) ? 1 : 0)
+/*
+#define DIRECT_MAP(tp, var, op) do { \
+	(tp)->var op; \
+	if ((tp)->t_mpcb->direct_map) (tp)->t_mpcb->ds_##var = (tp)->var; \
+} while(0)
+*/
+
+struct mpcb *
+		mp_newmpcb(struct inpcb *);
+void 	mp_discardcb(struct mpcb *mp);
+void	mp_do_reass(struct socket *so);
+void	tcp_ackmap(struct tcpcb *tp, struct tcphdr *th);
+
 #endif /* _KERNEL */
 
 #endif /* _NETINET_TCP_VAR_H_ */
diff -r 11a8f1275a38 sys/sys/sockbuf.h
--- a/sys/sys/sockbuf.h	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/sys/sockbuf.h	Mon Mar 11 02:59:51 2013 +1100
@@ -52,6 +52,7 @@
 #define	SB_NOCOALESCE	0x200		/* don't coalesce new data into existing mbufs */
 #define	SB_IN_TOE	0x400		/* socket buffer is in the middle of an operation */
 #define	SB_AUTOSIZE	0x800		/* automatically size socket buffer */
+#define SB_DEFERACCT 0x1000		/* need to account for sb_cc and sb_actual separately */
 
 #define	SBS_CANTSENDMORE	0x0010	/* can't send more data to peer */
 #define	SBS_CANTRCVMORE		0x0020	/* can't receive more data from peer */
@@ -89,7 +90,8 @@
 					 * record in socket buffer */
 	struct	mbuf *sb_sndptr; /* (c/d) pointer into mbuf chain */
 	u_int	sb_sndptroff;	/* (c/d) byte offset of ptr into chain */
-	u_int	sb_cc;		/* (c/d) actual chars in buffer */
+	u_int	sb_cc;		/* (c/d) actively mapped bytes b/w application and protocol  */
+	u_int	sb_actual;	/* (c/d) actual chars in buffer */
 	u_int	sb_hiwat;	/* (c/d) max actual char count */
 	u_int	sb_mbcnt;	/* (c/d) chars of mbufs used */
 	u_int   sb_mcnt;        /* (c/d) number of mbufs in buffer */
@@ -158,6 +160,10 @@
 int	sblock(struct sockbuf *sb, int flags);
 void	sbunlock(struct sockbuf *sb);
 
+/* function to return sb_cc, i.e. chars in sockbuf */
+unsigned int sbgetcc(struct sockbuf *sb);
+
+
 /*
  * How much space is there in a socket buffer (so->so_snd or so->so_rcv)?
  * This is problematical if the fields are unsigned, as the space might
@@ -170,7 +176,10 @@
 
 /* adjust counters in sb reflecting allocation of m */
 #define	sballoc(sb, m) { \
+	(sb)->sb_actual += (m)->m_len; \
 	(sb)->sb_cc += (m)->m_len; \
+	if ((sb)->sb_flags & SB_DEFERACCT) KASSERT((sb)->sb_cc <= (sb)->sb_actual, ("sb_cc greater than actual\n")); \
+	else KASSERT((sb)->sb_cc == (sb)->sb_actual, ("SB_DEFER sb_cc greater != actual\n")); \
 	if ((m)->m_type != MT_DATA && (m)->m_type != MT_OOBDATA) \
 		(sb)->sb_ctl += (m)->m_len; \
 	(sb)->sb_mbcnt += MSIZE; \
@@ -183,7 +192,10 @@
 
 /* adjust counters in sb reflecting freeing of m */
 #define	sbfree(sb, m) { \
-	(sb)->sb_cc -= (m)->m_len; \
+	if((sb)->sb_flags & SB_DEFERACCT) KASSERT((int)(sb)->sb_actual - (m)->m_len >= 0 && (sb)->sb_cc <= (sb)->sb_actual - (m)->m_len, ("SB_DEFERACCT sb_cc/sb_actual accounting error: sb_cc %u, sb_actual %u, len %d", (sb)->sb_cc, (sb)->sb_actual, (m)->m_len)); \
+	else KASSERT((int)(sb)->sb_cc - (m)->m_len >= 0 && (int)(sb)->sb_actual - (m)->m_len >= 0 && (sb)->sb_cc - (m)->m_len <= (sb)->sb_actual - (m)->m_len && (sb)->sb_cc == (sb)->sb_actual, ("sb_cc/sb_actual accounting error: sb_cc %u, sb_actual %u, len %d", (sb)->sb_cc, (sb)->sb_actual, (m)->m_len)); \
+	(sb)->sb_actual -= (m)->m_len; \
+	if (!((sb)->sb_flags & SB_DEFERACCT)) (sb)->sb_cc -= (m)->m_len; \
 	if ((m)->m_type != MT_DATA && (m)->m_type != MT_OOBDATA) \
 		(sb)->sb_ctl -= (m)->m_len; \
 	(sb)->sb_mbcnt -= MSIZE; \
diff -r 11a8f1275a38 sys/sys/socketvar.h
--- a/sys/sys/socketvar.h	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/sys/socketvar.h	Mon Mar 11 02:59:51 2013 +1100
@@ -340,11 +340,16 @@
 	    struct thread *td);
 int	sopoll_generic(struct socket *so, int events,
 	    struct ucred *active_cred, struct thread *td);
+int	sopoll_mpstream(struct socket *so, int events,
+	    struct ucred *active_cred, struct thread *td);
 int	soreceive(struct socket *so, struct sockaddr **paddr, struct uio *uio,
 	    struct mbuf **mp0, struct mbuf **controlp, int *flagsp);
 int	soreceive_stream(struct socket *so, struct sockaddr **paddr,
 	    struct uio *uio, struct mbuf **mp0, struct mbuf **controlp,
 	    int *flagsp);
+int	soreceive_mpstream(struct socket *so, struct sockaddr **paddr,
+	    struct uio *uio, struct mbuf **mp0, struct mbuf **controlp,
+	    int *flagsp);
 int	soreceive_dgram(struct socket *so, struct sockaddr **paddr,
 	    struct uio *uio, struct mbuf **mp0, struct mbuf **controlp,
 	    int *flagsp);
